﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head><title>Files and Audit Logs Transfer</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Files and Audit Logs Transfer</h1>
        <h2 id="FilesandAuditLogsTransfer-Overview">Overview</h2>
        <p>This section explains the process that the field team/project team can take to exchange files with customers. The&#160;files could be related to feed-file based HR Import, Audit logs or any other file exchange.</p>
        <h2 id="FilesandAuditLogsTransfer-ProcesstogetFilefromCustomerEnvironment">Process to get File from Customer Environment</h2>
        <p>There are three approaches that can be followed to get files from Customer Environments.</p>
        <ol>
            <li>File exchange using S3 (This is the preferred approach if Customer has an AWS account)</li>
            <li>SFTP based file transfer (For customers who don’t have an AWS account)</li>
            <li>File exchange using Azure Storage Account (This approach can be followed if the customer has Azure tenant)</li>
        </ol>
        <h3 id="FilesandAuditLogsTransfer-FileexchangeusingS3">File exchange using S3</h3>
        <p>This section provides details of obtaining the files from the customer S3 bucket.</p>
        <h4 id="FilesandAuditLogsTransfer-GettingFilefromCustomerS3Bucket">Getting File from Customer S3 Bucket</h4>
        <p>You can get files from the Customer S3 bucket by using S3 Copy Operation. Customers must grant Saviynt’s AWS&#160;account access to S3 bucket set up in their AWS account by using AWS S3 Bucket Policy.</p>
        <p>Perform the following steps to get the file from customer S3 Bucket:</p>
        <ol>
            <li>
                <p class="auto-cursor-target">In customer AWS Account, customer needs to attach the following bucket policy to the bucket from where&#160;Saviynt can get the files.</p>
                <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                    <ol style="list-style-type: lower-alpha;">
                        <li>
                            <p class="note">Saviynt only requires s3:GetBucketLocation,s3:GetObject, s3:ListBucket permissions to copy the files from&#160;Customer AWS Account.</p>
                        </li>
                        <li>
                            <p class="note">Saviynt’s Infra team will provide the 12-digit account ID for the Saviynt’s AWS account.</p>
                        </li>
                    </ol>
                </div>
                <p>{</p>
                <p>"Id": "Policy1488826126935",</p>
                <p>"Version": "2012-10-17",</p>
                <p>"Statement": [</p>
                <p>{</p>
                <p>"Sid": "Stmt1488826121402",</p>
                <p>"Action": [</p>
                <p>"s3:GetBucketLocation",</p>
                <p>"s3:GetObject",</p>
                <p>"s3:ListBucket"</p>
                <p>],</p>
                <p>"Effect": "Allow",</p>
                <p>"Resource": [</p>
                <p>"arn:aws:s3:::&lt;CustomerS3BucketName&gt;",</p>
                <p>"arn:aws:s3:::&lt;CustomerS3BucketName&gt;/*"</p>
                <p>],</p>
                <p>"Principal": {</p>
                <p>"AWS": [</p>
                <p>"arn:aws:iam::&lt;Saviynt AWS Account 12 Digit ID&gt;:root"</p>
                <p>]</p>
                <p>},</p>
                <p>"Condition": {</p>
                <p>"IpAddress": {"aws:SourceIp":</p>
                <p>["&lt;Saviynt NAT IP ADDRESS1&gt;/32", "&lt;Saviynt NAT IP ADDRESS1&gt;/32"]</p>
                <p>}</p>
                <p>}</p>
                <p>}</p>
                <p>]</p>
                <p>}</p>
            </li>
            <li>
                <p class="auto-cursor-target">On Saviynt side, attach the following IAM Policy to EC2 IAM Role to delegate access to the bucket in the Customer&#160;AWS account.</p>
                <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                    <p class="note">The customer will need to provide the S3 bucket name for the below Policy.</p>
                </div>
            </li>
            <li>
                <p class="auto-cursor-target">Once the permissions are setup at both customer and Saviynt side following command can be used to get the&#160;files.</p>
                <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                    <p class="note">By default AWS CLI commands are sent over SSL channel: <a href="http://docs.aws.amazon.com/cli/latest/reference/">http://docs.aws.amazon.com/cli/latest/reference/</a></p>
                </div>
            </li>
            <li>
                <p>aws s3 cp s3://&lt;CustomerS3BucketName&gt;/&lt;File&gt; /&lt;EC2Path&gt;/&lt;FileName&gt;</p>
            </li>
            <li>The command in the previous step can be run manually from EC2 instance for Adhoc requirements or you can put this inside a Cron&#160;expression to automatically get the files on a scheduled basis.</li>
            <li>A&#160;sample cron expression given below:<br /><ol style="list-style-type: lower-alpha;"><li><p>On EC2 Instance, go to <label class="filename-path">/etc/cron.d/</label> directory (Note that this script need to be put on all the EC2 Instances)</p></li><li><p>Create a file and give it an appropriate name<br />Copy paste below shell Script. Make sure you change the path in this script with Customer S3 bucket path and&#160;Destination. Also change the time in below cron expression based on when you want to copy the files on EC2.</p></li></ol><p><span class="attr">SHELL=/bin/bash
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
00 16 * * * root aws s3 cp s3://saviynt-share-prd-use-s3/feed/timemployee.txt
/opt/saviynt/Import/Datafiles/schemauser_timeemployee.txt;
00 16 * * * root aws s3 cp s3://saviynt-share-prd-use-s3/feed/timcontractor.txt
/opt/saviynt/Import/Datafiles/schemauser_timcontractor.txt;</span></p></li>
        </ol>
        <p class="auto-cursor-target">
            <img src="../Resources/Images/Screenshot of Cron Expression.png" />
            <br />Figure: Screenshot of Cron Expression</p>
        <h3 id="FilesandAuditLogsTransfer-PuttingFilesonCustomerS3Bucket">Putting Files on Customer S3 Bucket</h3>
        <p>For requirements like send audit Logs to Customer environment you can put files on Customer S3 bucket by using&#160;S3 Copy Operation. Customer must create a S3 bucket for Saviynt to upload files.</p>
        <p>Perform the following steps, to put files on customer S3 Bucket:</p>
        <ol>
            <li>
                <p class="auto-cursor-target">In customer AWS Account, customer need to attach the following bucket policy to the bucket where Saviynt can&#160;put the files.</p>
                <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                    <p class="note">a. Saviynt only requires s3:GetBucketLocation, s3:PutObject, s3:ListBucket permissions to put the files On&#160;Customer S3 Bucket.<br />b. Saviynt’s Infra team will provide the 12-digit account ID for the Saviynt’s AWS account.</p>
                </div>
                <p>{</p>
                <p>"Version": "2012-10-17",</p>
                <p>"Id": "Policy1488826126935",</p>
                <p>"Statement": [</p>
                <p>{</p>
                <p>"Sid": "Stmt1488826121402",</p>
                <p>"Effect": "Allow",</p>
                <p>"Principal": {</p>
                <p>"AWS": " arn:aws:iam::&lt;Saviynt AWS Account 12 Digit ID&gt;:root" },</p>
                <p>"Action": [</p>
                <p>"s3:GetBucketLocation",</p>
                <p>"s3:PutObject",</p>
                <p>"s3:ListBucket" ],</p>
                <p>"Resource": [</p>
                <p>"arn:aws:s3:::&lt;CustomerS3BucketName&gt;",</p>
                <p>"arn:aws:s3:::&lt;CustomerS3BucketName&gt;/*" ],</p>
                <p>"Condition": {</p>
                <p>"IpAddress": { "aws:SourceIp":</p>
                <p>["&lt;Saviynt NAT IP ADDRESS1&gt;/32", "&lt;Saviynt NAT IP ADDRESS1&gt;/32"]</p>
                <p>}</p>
                <p>}</p>
                <p>}</p>
                <p>]</p>
                <p>}</p>
            </li>
            <li>
                <p class="auto-cursor-target">Once the permissions are setup at customer side following command can be used to get the files.</p>
                <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                    <p class="note">By default AWS CLI commands are sent over SSL channel: <a href="http://docs.aws.amazon.com/cli/latest/reference/" class="external-link" rel="nofollow">http://docs.aws.amazon.com/cli/latest/reference/</a></p>
                </div>
                <p><span class="attr">aws s3 cp /home/ec2-user/&lt;FileName&gt; s3://&lt;CustomerS3BucketName&gt;/&lt;File&gt;If you have more than one file, say you want to copy all the files with extension csv from a folder and want to exclude all other files below command can be used:
aws s3 cp /home/ec2-user/* s3://&lt;CustomerS3BucketName/ --recursive --exclude "*" --include "*.csv"</span>
                </p>
            </li>
            <li>Above command can be run manually from EC2 instance for adhoc requirements or you can put this inside a Cron&#160;expression to automatically get the files on a scheduled basis.<br /></li>
            <li>A sample cron expression given below:<ol style="list-style-type: lower-alpha;"><li>On EC2 Instance, go to<label class="filename-path"> /etc/cron.d/</label> directory (Note that this script need to be put on all the EC2 Instances).</li><li><p class="auto-cursor-target">Create a file and give it an appropriate name.<br />Copy paste below shell Script. Make sure you change the path in this script with Customer S3 bucket path and&#160;Destination. Also change the time in below cron expression based on when you want to copy the files on EC2.</p><p class="auto-cursor-target"><span class="attr">SHELL=/bin/bash
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
00 16 * * * root aws s3 cp s3://saviynt-share-prd-use-s3/feed/timemployee.txt
/opt/saviynt/Import/Datafiles/schemauser_timeemployee.txt;
00 16 * * * root aws s3 cp s3://saviynt-share-prd-use-s3/feed/timcontractor.txt
/opt/saviynt/Import/Datafiles/schemauser_timcontractor.txt;</span></p><pre class="syntaxhighlighter-pre" xml:space="preserve"><img src="../Resources/Images/Screenshot of Cron Expression1.png" /></pre><p xml:space="preserve">Figure: Screenshot of Cron Expression</p></li></ol></li>
        </ol>
        <h3 id="FilesandAuditLogsTransfer-SFTPBasedFileTrasfer(ForbothFilePush/Pull)">SFTP Based File Trasfer (For both File Push/Pull)</h3>
        <p>To perform SFTP based file transfer, perform the following steps:</p>
        <ol>
            <li>Customer will provide SFTP location and credentials to connect to their SFTP Server which will be used to&#160;push/pull files as required.</li>
            <li>The credentials will be stored in AWS EIC Parameter Store on Saviynt end and a command will be&#160;provided by DevOps team to Project team use that string for SFTP Password.</li>
            <li>
                <p class="auto-cursor-target">No scripts or text files on Server should have any kind of credentials in plain text. DevOps team will delete&#160;any such files found to be in accordance of such security violations.<br />Example of SFTP Pul</p>
                <p><span class="attr">#!/bin/bash
export SSHPASS=`aws eic get-parameters --names "customer1-target-sftppass" --with-decryption --query
"Parameters[*]["Value"]" --output text --region us-east-1`
sshpass -e sftp -oBatchMode=no -b – user@server &lt;&lt; !
lcd /opt/saviynt/Import/
get Prod/Out/SCHEMA*
bye
!
echo "File copied"</span>
                </p>
            </li>
        </ol>
        <h3 id="FilesandAuditLogsTransfer-FileexchangeusingAzureStorageAccount">File exchange using Azure Storage Account&#160;</h3>
        <p>To perform file exchange using Azure Storage Account, perform the following steps:</p>
        <ol>
            <li>Create Azure Storage in Storage Account as shown below<br /><img src="../Resources/Images/Azure Storage.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;height: 500px;width: 900px;" /><br />Once created, it will look as follows.<br /><img src="../Resources/Images/Azure Storage1.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;width: 900px;height: 500px;" /><br /></li>
            <li>Click on File Share and create a container as shown as follows.<br /><img src="../Resources/Images/Azure Storage2.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;width: 900px;height: 300px;" /><br /></li>
            <li>Share the details of File Container URL along with Key1 or Key2 as shown below.<br /><img src="../Resources/Images/Azure Storage3.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" /><br /><br /><img src="../Resources/Images/Azure Storage4.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;width: 900px;height: 500px;" /><br /></li>
            <li>Access to<label class="filename-path"> blob/fileshare</label> container.<br />Need access to the above Fileshare Storage/ Blob Storage by getting details of key and url of storage&#160;account along with whitelisting of IP at customer end if the storage account is of customer or if the&#160;storage account is at our end.<br /><img src="../Resources/Images/Azure Storage5.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;width: 900px;height: 500px;" /><br /></li>
            <li>
                <p class="auto-cursor-target">AZ Copy for push and pull the file from Azure Storage Account.<br />Saviynt will be using azcopy powershell module on linux server to pull and push the data from customer&#160;storage account.</p>
                <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                    <p class="note">Need to install AzCopy binary on Linux Azcopy executables on windows.</p>
                </div>
                <ul>
                    <li>
                        <p><b>To Push Single file</b>:<br />This command will Push a file name to the storage container in the container.<br /><span class="attr">azcopy --source &lt;complete-source-file-path&gt; --destination &lt;blobstorage url&gt; --dest-key &lt;destkey&gt;</span></p>
                    </li>
                </ul>
                <ul>
                    <li>
                        <p><b>To Push Files in a folder recursively</b>:<br />This command will push all files in the target reports folder to the storage container fscsccoresvcsuse2sav.<br /><span class="attr">azcopy --source &lt;source-folder-path&gt; --destination &lt;destination-blob-storage&gt; --dest-key &lt;destkey&gt; --recursive</span></p>
                    </li>
                    <li>
                        <p><b>To Pull a Single File</b>
                            <br />This will pull a file on the storage container to the local folder.<br /><span class="attr">azcopy --source &lt;sourcefilestorageaccount&gt; --destination &lt;destinationfilepath&gt; --source-key &lt;storageaccountkey &gt;</span><br /></p>
                    </li>
                    <li>
                        <p><b>To Pull multiple files recursively:</b>
                            <br />This will pull all files from storage container to a local folder &lt; path to local folder &gt;<br /><span class="attr">azcopy --source &lt; sourcefilestorageaccount &gt; --destination &lt; destinationfilepath &gt; --source-key &lt;storageaccountkey&gt; --recursive</span></p>
                    </li>
                </ul>
            </li>
        </ol>
    </body>
</html>